﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.8
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private cmdAnterior As B4XView
	Private cmdSiguiente As B4XView
	Private iconoCamara As B4XView
	
	#if B4A
	Private const tempImageFile As String = "tempimage.jpg"
	Private Provider As FileProvider
	Private ion As Object
	#Else If B4i
	Private Camera As Camera
	#end if
	
	'Private pageCamara As P_Camara
	
	Private bmptmp As Bitmap
	Private imgFoto2 As B4XImageView
	Private img3 As B4XImageView
	Private img2 As B4XImageView
	Private img1 As B4XImageView
	Private q1 As B4XView
	Private q2 As B4XView
	Private q3 As B4XView
	Private Tiene1 As Boolean
	Private Tiene2 As Boolean
	Private Tiene3 As Boolean
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	imgFoto2=XUIViewsUtils.CreateB4XImageView
	
	bmptmp.InitializeMutable(640dip,480dip)
	imgFoto2.Bitmap=bmptmp

	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("frmCargaEvidencia")
	
	img1.Bitmap=bmptmp
	img2.Bitmap=bmptmp
	img3.Bitmap=bmptmp
	q1.Visible=False
	q2.Visible=False
	q3.Visible=False
	Tiene1=False
	Tiene2=False
	Tiene3=False
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub cmdSiguiente_Click

End Sub
private Sub B4XPage_Appear
	
End Sub
Private Sub B4XPage_CloseRequest As ResumableSub
	B4XPages.ClosePage(Me)
	Return True
End Sub
Private Sub cmdAnterior_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub iconoCamara_Click
	TomaFoto
End Sub
Public Sub PoneFoto (bmp As B4XBitmap)
	
	If Tiene1=False Then
		img1.ResizeMode="FILL"
		img1.Bitmap=bmp
		Tiene1=True
		q1.Visible=True
		Return
	End If
	
	If Tiene2=False Then
		img2.ResizeMode="FILL"
		img2.Bitmap=bmp
		Tiene2=True
		q2.Visible=True
		Return
	End If
	
	If Tiene3=False Then
		img3.ResizeMode="FILL"
		img3.Bitmap=bmp
		Tiene3=True
		q3.Visible=True
		Return
	End If
	
End Sub
Private Sub q1_Click
	img1.Bitmap=img2.Bitmap
	img2.Bitmap=img3.Bitmap
	img3.Bitmap=bmptmp
	
	If Tiene3=True Then
		Tiene3=False
		q3.Visible=False
	Else if Tiene3=False And Tiene2=True Then
		Tiene2=False
		q2.Visible=False
	Else
		Tiene1=False
		q1.Visible=False
	End If
	
End Sub
Private Sub q2_Click
	img2.Bitmap=img3.Bitmap
	img3.Bitmap=bmptmp
	
	If Tiene3=True Then
		Tiene3=False
		q3.Visible=False
	Else
		Tiene2=False
		q2.Visible=False
	End If
	
End Sub
Private Sub q3_Click
	img3.Bitmap=bmptmp
	Tiene3=False
	q3.Visible=False
End Sub
Public Sub TomaFoto
	#if B4A
	Provider.Initialize
	#Else If B4i
	Camera.Initialize("Camera", B4XPages.GetNativeParent(Me))
	#end if

	TakePicture (imgFoto2.Bitmap.As(B4XBitmap).Width , imgFoto2.Bitmap.As(B4XBitmap).Height)
	Wait For Image_Available(Success As Boolean, bmp As B4XBitmap)
	If Success Then
		'imgFoto.SetBitmap(bmp)
		PoneFoto(bmp)
	End If
End Sub
#if B4A
Private Sub TakePicture (TargetWidth As Int, TargetHeight As Int)
	Dim i As Intent
	i.Initialize("android.media.action.IMAGE_CAPTURE", "")
	File.Delete(Provider.SharedFolder, tempImageFile)
	Dim u As Object = Provider.GetFileUri(tempImageFile)
	i.PutExtra("output", u) 'the image will be saved to this path
	Try
		StartActivityForResult(i)
		Wait For ion_Event (MethodName As String, Args() As Object)
		Dim bmp As B4XBitmap
		If -1 = Args(0) Then
			Try
				Dim in As Intent = Args(1)
				If File.Exists(Provider.SharedFolder, tempImageFile) Then
					Dim Exif As ExifData
					Exif.Initialize(Provider.SharedFolder, tempImageFile)
					bmp = LoadBitmapSample(Provider.SharedFolder, tempImageFile, Max(TargetWidth, TargetHeight), Max(TargetWidth, TargetHeight))
					Log("Orientation: " & Exif.getAttribute(Exif.TAG_ORIENTATION))
					Select Exif.getAttribute(Exif.TAG_ORIENTATION)
						Case Exif.ORIENTATION_ROTATE_180 '3
							bmp = bmp.Rotate(180)
						Case Exif.ORIENTATION_ROTATE_90 '6
							bmp = bmp.Rotate(90)
						Case Exif.ORIENTATION_ROTATE_270 '8
							bmp = bmp.Rotate(270)
					End Select
					bmp = bmp.Resize(TargetWidth, TargetHeight, True)
				Else If in.HasExtra("data") Then 'try to get thumbnail instead
					Dim jo As JavaObject = in
					bmp = jo.RunMethodJO("getExtras", Null).RunMethod("get", Array("data"))
				End If
			Catch
				Log(LastException)
			End Try
		End If
		CallSubDelayed3(Me, "Image_Available", bmp.IsInitialized, bmp)
	Catch
		ToastMessageShow("Camera is not available.", True)
		Log(LastException)
		CallSubDelayed3(Me, "Image_Available", False, Null)
	End Try
End Sub
Sub StartActivityForResult(i As Intent)
	Dim jo As JavaObject = Me
	jo = jo.RunMethod("getBA", Null)
	ion = jo.CreateEvent("anywheresoftware.b4a.IOnActivityResult", "ion", Null)
	jo.RunMethod("startActivityForResult", Array(ion, i))
End Sub
#else if B4i
Private Sub TakePicture (TargetWidth As Int, TargetHeight As Int)
	Camera.TakePicture
	Dim TopPage As String = B4XPages.GetManager.GetTopPage.Id
	Wait For Camera_Complete (Success As Boolean, Image As Bitmap, VideoPath As String)
	B4XPages.GetManager.mStackOfPageIds.Add(TopPage) 'this is required as the page will be removed from the stack when the external camera page appears.
	If Success Then
		Dim bmp As B4XBitmap = Image
		bmp.Resize(TargetWidth, TargetHeight, True)
		CallSubDelayed3(Me, "Image_Available", True, bmp)
	Else
		CallSubDelayed3(Me, "Image_Available", False, Null)
	End If
End Sub
#end if


